var $=function(s){
	return typeof s=="string"?document.querySelector(s):s;
}
$.os=(function(){
	if(/iphone|ipod|ipad/gi.test(navigator.userAgent)){
		return "ios";
	}else if(/android/gi.test(navigator.userAgent)){
		return "android";
	}else{
		return "pc";
	}
})()
$.localStore=(function(){
	if(window.localStorage&&typeof window.localStorage.setItem=="function"&&typeof window.localStorage.getItem=="function"){
		return window.localStorage;
	}else{
		return {
			setItem:function(){},
			getItem:function(){return ""}
		}
	}
})()
$.cache={
	get:function(key){
		var v=$.localStore.getItem("cache_"+key);
		var t=$.localStore.getItem("cache_"+key+"_time");
		if(t&&Date.now()<t){
			return v;
		}else{
			return "";
		}
	},
	set:function(key,value,cacheTime){
		if(cacheTime&&!isNaN(cacheTime)){
			cacheTime=cacheTime*60000;
		}else{
			cacheTime=300000;
		}
		$.localStore.setItem("cache_"+key,value);
		$.localStore.setItem("cache_"+key+"_time",Date.now()+cacheTime);
	}
}
$.each=function(arr,fn){
	for(var i=0;i<arr.length;i++){
		fn(i,arr[i]);
	}
}
$.vs={
	getVersion:function(str,i){
		var vArr=str.toString().match(/[\d\.]+/g);
		if(isNaN(i))
			return vArr;
		else
			return vArr[i]||"";
	},
	compVersion:function(ver,cv){
		ver=ver.toString().split(/[^\d]+/);
		cv=cv.toString().split(/[^\d]+/);
		for(var i=0;i<ver.length;i++){
			if(ver[i]>(cv[i]||0))
				return 1;
			else if(ver[i]<(cv[i]||0))
				return -1;
		}
		return 0;
	}
}
$.fnSyncCB=[];
$.fnSync=function(fnArr,callback){
	var cbArr=[];
	var count=0;
	for(var i=0;i<fnArr.length;i++){
		var j=$.fnSyncCB.length;
		$.fnSyncCB[j]=function(jj){return function(){
			cbArr[jj]=arguments;
			count++;
			if(count==fnArr.length){
				callback(cbArr);
				$.fnSyncCB=[];
			}
		}}(j)
		try{
			eval(fnArr[i].replace(")",'$.fnSyncCB['+j+'])'));
		}catch(e){
			$.fnSyncCB[j]();
			console.log(i,e);
		}
	}
}
$.cookie={
	get:function(n){
		var m = document.cookie.match(new RegExp( "(^| )"+n+"=([^;]*)(;|$)"));
		return !m?"":m[2];
	},
	set:function(name,value,domain,path,hour){ 
		var expire = new Date(); 
		expire.setTime(expire.getTime() + (hour?3600000 * hour:30*24*60*60*1000));
		document.cookie=name+"="+value+"; "+"expires="+expire.toGMTString()+"; path="+(path?path:"/")+"; "+(domain?("domain="+domain+";"):""); 
	},
	del:function(name, domain, path) {
		document.cookie=name+"=; expires=Mon, 26 Jul 1997 05:00:00 GMT; path="+(path?path:"/")+"; "+(domain?("domain="+domain+";"):""); 
	}
};
$.search={
	get:function(n){
		var m = location.href.match(new RegExp( n+"=([^&]*)"));
		return !m?"":m[1];
	}
}
$.winName = {
    set:function (n, v) {
        var name = window.name || "";
        v = encodeURIComponent(v);
        if (name.match(new RegExp(";" + n + "=([^;]*)(;|$)"))) {//先验证是否存在
            window.name = name.replace(new RegExp(";" + n + "=([^;]*)"), ";" + n + "=" + v);
        } else {
            window.name = name + ";" + n + "=" + v;
        }
    },
    get:function (n) {
        var name = window.name || "";
        var v = name.match(new RegExp(";" + n + "=([^;]*)(;|$)"));
        return  decodeURIComponent(v ? v[1] : "");
    },
    remove:function (n) {
        var name = window.name || "";
        window.name = name.replace(new RegExp(";" + n + "=([^;]*)"), "");
    },
    clear:function () {
        window.name = "";
    }
};
$.get=function(url,param,callback,cacheName,cacheTime){
	if(g_host){
		url=g_host+url;
	}
	if(cacheName){
		var cache=$.localStore.getItem(url+"|"+cacheName)
		if(cache){
			callback(JSON.parse(cache));
			var useCache=1;
			var ct=$.localStore.getItem(url+"|"+cacheName+"_time")||0;
			if(Date.now()<ct){
				return;
			}
		}
	}
	if(cacheTime&&!isNaN(cacheTime)){
		cacheTime=cacheTime*60000;
	}else{
		cacheTime=300000;
	}
	var xmlHttp = new XMLHttpRequest();
	var arr=[];
	for(var k in param){
		arr.push(encodeURIComponent(k)+"="+encodeURIComponent(param[k]));
	}
	xmlHttp.open("GET",url+(arr.length?"?"+arr.join('&'):""),true);
	//xmlHttp.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
	xmlHttp.onreadystatechange = function(){
		if(xmlHttp.readyState == 4){
			if(xmlHttp.status == 200){
				var json;
				try{
					json=JSON.parse(xmlHttp.responseText)
				}catch(e){
					json={ret:999,msg:"wrong json"};
				}
				if(json.ret==0&&cacheName){
					$.localStore.setItem(url+"|"+cacheName,xmlHttp.responseText);
					$.localStore.setItem(url+"|"+cacheName+"_time",Date.now()+cacheTime);
				}
				if(!useCache||xmlHttp.responseText!=cache){
					callback(json);
				}
			}else if(xmlHttp.status>0&&!useCache){
				//GCApi.showWarningToast('网络不给力:'+xmlHttp.status);
			}
		}
	};
	xmlHttp.onerror=function(){
		//if(!useCache)
			//GCApi.showWarningToast('网络不给力');
	}
	xmlHttp.send(null);
}
$.post=function(url,param,callback,cacheName,cacheTime){
	if(g_host){
		url=g_host+url;
	}
	if(typeof iOSQQApi.data.fetchJson=="function"){
		$.fetchJson(url,param,callback,"POST",cacheName,cacheTime)
		return;
	}
	if(cacheName){
		var cache=$.localStore.getItem(url+"|"+cacheName)
		if(cache){
			callback(JSON.parse(cache));
			var useCache=1;
			var ct=$.localStore.getItem(url+"|"+cacheName+"_time")||0;
			if(Date.now()<ct){
				return;
			}
		}
	}
	if(cacheTime&&!isNaN(cacheTime)){
		cacheTime=cacheTime*60000;
	}else{
		cacheTime=300000;
	}
	var xmlHttp = new XMLHttpRequest();
	var arr=[];
	for(var k in param){
		arr.push(encodeURIComponent(k)+"="+encodeURIComponent(param[k]));
	}
	xmlHttp.open("POST",url,true);
	xmlHttp.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
	xmlHttp.onreadystatechange = function(){
		if(xmlHttp.readyState == 4){
			if(xmlHttp.status == 200){
				var json;
				try{
					json=JSON.parse(xmlHttp.responseText)
				}catch(e){
					json={ret:999,msg:"wrong json"};
				}
				if(json.ret==0&&cacheName){
					$.localStore.setItem(url+"|"+cacheName,xmlHttp.responseText);
					$.localStore.setItem(url+"|"+cacheName+"_time",Date.now()+cacheTime);
				}
				if(!useCache||xmlHttp.responseText!=cache){
					callback(json);
				}
			}else if(xmlHttp.status>0&&!useCache){
				//GCApi.showWarningToast('网络不给力:'+xmlHttp.status);
			}
		}
	};
	xmlHttp.onerror=function(){
		//if(!useCache)
			//GCApi.showWarningToast('网络不给力');
	}
	xmlHttp.send(arr.join('&')||null);
}
$.loadScript=function (src, callback, err) {   
  var tag = document.createElement("script");
  if(callback){
	  tag.onload = tag.onreadystatechange = function() {
		  if ( !this.readyState ||this.readyState === "loaded" || this.readyState === "complete") {
			  // 执行回调
			  callback();
			  // Handle memory leak in IE
			  tag.onload = tag.onreadystatechange = null;
			  if (tag.parentNode ) {
				  tag.parentNode.removeChild( tag );
			  }
		  }
	  };			
  } 
  tag.src = src;
  document.getElementsByTagName("head")[0].appendChild(tag);
}
$.extend=function(obj){
	if(arguments.length>1)
		for(var i=1,l=arguments.length;i<l;i++)
			for(var k in arguments[i])
				obj[k]=arguments[i][k];
	return obj;
}
$.get_sbkn=function(key){
	var str = decodeURIComponent(key);
	if(!str){
		return "";
	}
	var hash = 5381;
	for(var i = 0, len = str.length; i < len; ++i){
		hash += (hash << 5) + str.charAt(i).charCodeAt();
	}
	return hash & 0x7fffffff;
};
$.get_bkn=function(){
	var str = $.cookie.get('skey');
	if(!str){
		return "";
	}
	var hash = 5381;
	for(var i = 0, len = str.length; i < len; ++i){
		hash += (hash << 5) + str.charAt(i).charCodeAt();
	}
	return hash & 0x7fffffff;
};
$.replaceTpl=function(tpl,value,common){
	common=common||{};
	var strArr=[];
	if(!isNaN(value.length)){
		for(var i=0;i<value.length;i++){
			strArr.push($.replaceTpl(tpl,value[i],common))
		}
		return strArr.join('');
	}else{
		return tpl.replace(/{#([^\}]+)}/g,function(sign,key,index,str){	//"{#name}", "name", 6, "<span>{#name}</span>"
			var keySplit=key.split("|");
			if(keySplit.length>1){		//枚举型{#type|a|b|c}, type值0,1,2对应显示a,b,c
				key=keySplit.shift();
				return keySplit[value[key]||common[key]||0]||"";
			}else if(typeof value[key]=="undefined"){		//值型
				return typeof common[key]=="undefined"?"":common[key];
			}else{
				return value[key];
			}
		});
	}
}
$.isdspeed=function(f3,f4,rand){
	rand=rand||0.3;
	var ids=[];
	for(var k in f4){
		ids.push(k+"="+f4[k]);
	}
	var speedImg = new Image();
	if (Math.random() < rand){
		speedImg.src = "http://isdspeed.qq.com/cgi-bin/r.cgi?flag1=7718&flag2=127&flag3="+f3+"&"+ids.join("&");
	}
}
//;(function(){
//	var node=document.createElement('script');
//	var pladId=$.search.get('plat')||'qq';
//	var script=document.getElementsByTagName('script')[0];
//	node.src="http://pingjs.qq.com/tcss.ping.js";
//	node.type='text/javascript';
//	node.onload=node.onerror=node.onreadystatechange=function(){
//		/loaded|complete|undefined/.test(node.readyState)&&function(){
//			node.onload=node.onerror=node.onreadystatechange=null;
//			node.parentNode.removeChild(node); 
//			node=undefined;
//			pgvMain({senseParam:pladId});
//		}();
//	}; 
//	script.parentNode.insertBefore(node,script);
//})();
;(function(){
	if($.localStore.clear&&!$.localStore.getItem("clearsid")){
		$.localStore.clear();
		$.localStore.setItem("clearsid",1)
	}
	
})()
;(function(){
	var url="/report/action";	//http://gamecentertest.cs0309.3g.qq.com
	var param={
		sid:"",
		qappid:"",
		osv:"",
		tt:0,
		rp_type:"page"
	}
	var reportItems=[];
	var reportTimer=0;
	var reportAtonce=function(callback){
		clearTimeout(reportTimer);
		sendReport(callback)
	}
	var reportIn=function(w){
		clearTimeout(reportTimer);
		reportTimer=setTimeout(function(){
			sendReport()
		},w*1000)
	}
	var sendReport=function(callback){
		var xmlHttp = new XMLHttpRequest();
		var arr=[];
		param.r=Math.random();
		for(var k in param){
			arr.push(encodeURIComponent(k)+"="+encodeURIComponent(param[k]));
		}
		xmlHttp.open("POST",g_host+url+"?"+arr.join('&'),true);
		xmlHttp.setRequestHeader("Content-Type", "multipart/form-data");
			xmlHttp.onreadystatechange = function(){
				if(xmlHttp.readyState == 4){
					if(xmlHttp.status == 200){
						if(typeof callback!="function"){
							return;
						}
						var json;
						try{
							json=JSON.parse(xmlHttp.responseText)
						}catch(e){
							json={ret:999,msg:"wrong json"};
						}
						callback(json)
					}
				}
			};
		xmlHttp.send(JSON.stringify({"items":reportItems}));
		reportItems=[];
	}
	$.jsreportConfig=function(cfg){
		for(var k in cfg){
			param[k]=cfg[k];
		}
	}
	$.jsreport=function(item,when,callback){
		reportItems.push(item);
		if(!when){
			reportAtonce(callback)
		}else{
			reportIn(when)
		}
	}
})()
// badjs
//window.onerror = function(msg, url, line){
//	alert(msg+" "+line);
//	return;
//	var t = new Image();
//	var e_info = encodeURIComponent('Script Error:' + msg +'|_|'+url+'|_|'+line+'|_|' + window.navigator.userAgent);
//	t.src = 'http://badjs.qq.com/cgi-bin/js_report?bid=88&mid=287738&msg='+e_info+'&v='+Math.random();
//	t = null;
//};
