var Feed = {
    CURRENT_PAGE_ID : 0,
    CONTENT_DOM : document.getElementById("feed_content"),
    PER_NUMBERS: 20,
    MAX_NUMBERS: 50,
    MAX_PAGE_ID:0,
    CURRENT_TIMESTAMP: new Date().getTime(),
    _status : null,
    _uin : GCApi.getUin(),
    _isRequesting : false,
    _isPullDown: false,

    display:function(){
        var that = Feed;
        that.CURRENT_PAGE_ID = 0;
        that._showTooltip("loading");
        
        that.CONTENT_DOM.innerHTML = "";
        //绑定下拉刷新和滚动底部加载更多的效果
        that._bindPullDownEvent();
        //先加载缓存
        that._loadCache();
        //后网络请求
        that._request();
   },

    _bindPullDownEvent:function(){
		if(window.GCApi&&GCApi.setClientWebviewPull){
			GCApi.setClientWebviewPull(true);
			return;
		}
    },

    _refreshComplete:function(){
        var up_arrow = document.getElementById("up_arrow_1");
        up_arrow.style['webkitTransform'] = 'rotate(0deg)';
        up_arrow.className = ' upDownArrow';
        Feed._isPullDown = false;
    },

    _loadCache:function(){
        var that = Feed, g = GCB, feedsCache = g._getCache("GC_FEEDS_"+that._uin);
        if (feedsCache){
            that.CONTENT_DOM.innerHTML = feedsCache;
        }
    },

    _request:function(){
        var that = Feed, g=GCB, _pageId = that.CURRENT_PAGE_ID, _perNum = that.PER_NUMBERS, _begin = _perNum * _pageId, _end = _perNum * (_pageId + 1) - 1;
        that._isRequesting = true;
        window["time_feeds"] = new Date();

        var url = g_host+"/game/feeds/get_detail?req_types=40&tt=1&beginnum=" + _begin + "&endnum=" + _end + "&sid=" + g._getSid(),
            xhr = new XMLHttpRequest();
        xhr.open("GET", url, true);
        xhr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
        xhr.setRequestHeader("If-Modified-Since", "0");
        window["time_feeds"] = new Date();
        xhr.onreadystatechange = function() {
            if (xhr.readyState == 4) {
                var g = GCB, that = Feed;
		        $.isdspeed(15,{"2":(new Date()-window["time_newFeedNum"])});
                that._isRequesting  = false;
                if ((xhr.status >= 200 && xhr.status < 300) || xhr.status == 304){
                    that._showFeed(xhr.responseText);
                }else{
					that._showTooltip(!xhr.status ? "neterror":"ajaxerror");
                }

                if (that._isPullDown){
                    that._refreshComplete();
                }
            }
        };
        try{
            xhr.send(null);
        }catch (e){
			that._showTooltip("ajaxerror");
        }
    },

    _showFeed:function(jsonStr){
        var json = eval('('+jsonStr+')'), g = GCB, that = Feed;

        if (json.total == 0 && that.CURRENT_PAGE_ID == 0 && (!json.placards || json.placards.length == 0)){
            that._showTooltip("nofeeds");
            return;
        }
        if (json.ret != 0){
			that._showTooltip("ajaxerror");
            return;
        }

        var notice = json.placards,feedHtml = [];
        if(notice && that.CURRENT_PAGE_ID == 0){
            var noticeLength = notice.length;
            if (noticeLength > 0){
                for(var j = 0; j < noticeLength; j++){
                    feedHtml = feedHtml.concat(that._generateNoticeContent(notice[j]));
                }
            }
        }

        var maxNum = that.MAX_NUMBERS,
            perNum = that.PER_NUMBERS,
            totalNum = parseInt(json.total,10) <= maxNum ? parseInt(json.total,10) : maxNum ,
            maxPageNum = parseInt(Math.ceil(totalNum/perNum),10) - 1,
            feedList = json.data,
            _length = feedList.length,
            currentPage = that.CURRENT_PAGE_ID;
        that.MAX_PAGE_ID = maxPageNum;
        that.CURRENT_TIMESTAMP = Math.floor(json.current_time/1000);
        if (_length > 0){
            for(var k = 0;k < _length; k++ ){
                feedHtml = feedHtml.concat(that._generateFeedContent(feedList[k]));
            }
        }
        if (that.CURRENT_PAGE_ID == 0){
            that._showTooltip("success");
            that.CONTENT_DOM.innerHTML = feedHtml.join("");
            localStorage.setItem("GC_FEEDS_"+that._uin, feedHtml.join(""))
        }else{
            that.CONTENT_DOM.insertAdjacentHTML("beforeend",feedHtml.join(""));
        }
        that._adjust();
        if ((that.CURRENT_PAGE_ID < that.MAX_PAGE_ID) && !that._isRequesting){
            setTimeout(function(){
                Feed.CURRENT_PAGE_ID = Feed.CURRENT_PAGE_ID + 1;
                Feed._request();
            },100);
        }
    },
	reportStartGame:function(appid){
		$.jsreport({
			actionname:"feed-local-startGame",
			appid:appid
		});
	},
	feedAction:function(appid){
		var g=getGameFromId(appid);
		GCB.isAppInstalled(g.pkgname, function(ret){
			if (ret) {
				GCB.startApp(appid, g);
			} else {
				gotoDetail(appid);
			}
		});
	},
    _generateFeedContent: function(feed){
        var status =  feed.requeststate == 0 ? 'class="dlBg"' : '',
            feedDesc =  feed.itemdesc.replace('{nickname}',(' '+ feed.sendnick +' ')),
            sendTime = Math.floor(feed.sendtime / 1000),
            alias = feed.alias;
        return ['<dl ',status,' appid="',feed.appid,'"><a onclick="Feed.reportStartGame(',feed.appid,')" href="javascript:Feed.feedAction(',feed.appid,');"><img src="',feed.sender_face,'"><dt>',feedDesc,'</dt><dd>', (this._timestamp2DateString(sendTime)+" "+alias) ,'</dd></a></dl>'];
    },

    _generateNoticeContent: function(notice){
        var noticeUrl = notice.des_url.replace(/\{SID\}/i,SID).replace(/\{UIN\}/i,g_uin);
        return ['<dl url="',noticeUrl,'"><a href="',noticeUrl,'"><img src="',notice.logo_url,'"><dt><i class="announcement">公告</i>',notice.content,'</dt><dd>', (this._timestamp2DateString(Math.floor(notice.sendtime / 1000))+" "+notice.appname) ,'</dd></a></dl>'];
    },
    
    _timestamp2DateString: function(timestamp){
        var today = new Date(Feed.CURRENT_TIMESTAMP);
        var date = new Date(timestamp);
        var days = parseInt((new Date(today.getFullYear(), today.getMonth(),today.getDate(),0, 0,0,0) -  new Date(date.getFullYear(), date.getMonth(),date.getDate(),0, 0,0,0))/(24*60*60*1000),10);
        var month = date.getMonth();
        month = month + 1;
        var day = date.getDate();
        var hour = date.getHours();
        hour = (hour < 10) ? ('0' + hour) : hour;
        var minute = date.getMinutes();
        minute = (minute < 10) ? ('0' + minute) : minute;

        if (days == 0){
            return  hour + ":" + minute;
        }else if(days == 1){
            return  "昨天"+hour + ":" + minute;
        }else if (days == 2){
            return  "前天"+hour + ":" + minute;
        }else{
            return  month + "月" + day + "日 " + hour + ':' + minute;;
        }
    },

    _showTooltip : function(status){
        var tooltip = document.getElementById("tooltip"),
            currentStatus = tooltip.getAttribute("status");
        if (status == "loading"){
            tooltip.style.display = "";
            tooltip.innerHTML = '<img src="../images/load.gif">正在加载...';
            tooltip.setAttribute("status","loading");
            return;
        }else if (status == "success"){
            tooltip.style.display = "none";
            tooltip.setAttribute("status","success");
            return;
        }else if (status == "nofeeds"){

            Feed.CONTENT_DOM.innerHTML = "";
            tooltip.innerHTML = '暂无消息';
            tooltip.style.display = "";
            tooltip.setAttribute("status","nofeeds");
            Feed._adjust();
            return;
        }else if (status == "neterror"){
            tooltip.innerHTML = '当前网络不可用，请检查你的网络设置';
            tooltip.style.display = "";
            tooltip.setAttribute("status","neterror");
            Feed._adjust();

            return;
        }else if (status == "ajaxerror"){
            tooltip.innerHTML = '糟糕出错了，请下拉刷新重试';
            tooltip.style.display = "";
            tooltip.setAttribute("status","ajaxerror");
            Feed._adjust();
            return;
        }
        return;
    },

    _adjust: function(){
        var wh = document.documentElement.clientHeight, bar = document.getElementById("bar_list_div"),
            bar_list = document.getElementById("feed_content");
        bar.style.height = Math.max(bar.offsetHeight, bar_list.offsetHeight+51) +"px";
    }
}